Index: src/uk/me/parabola/mkgmap/main/TypSaver.java
===================================================================
--- src/uk/me/parabola/mkgmap/main/TypSaver.java	(revision 4807)
+++ src/uk/me/parabola/mkgmap/main/TypSaver.java	(working copy)
@@ -55,11 +55,14 @@
 			if (familyId != foundFamily || productId != foundProduct) {
 				buffer.putChar(0x2f, (char) familyId);
 				buffer.putChar(0x31, (char) productId);
-
-				outfilename = makeOutName(filename);
+				outfilename= new File(args.getOutputDir(), new File(filename).getName()).getPath();
+				if (filename.equals(outfilename)) {
+					// don't overwrite source file
+					throw new ExitException(
+							"TYP has different family-id/product-id " + foundFamily + "/" + foundProduct);
+				}
 				writeAlteredTyp(outfilename, in, buf, n);
 			}
-
 		} catch (IOException e) {
 			throw new ExitException("TYP file cannot be opened or read: " + filename);
 		}
@@ -86,26 +89,4 @@
 			throw new ExitException("Could not write temporary TYP file: " + outFilename);
 		}
 	}
-
-	/**
-	 * Create a name for the patched file.
-	 *
-	 * We pre-pend a 'x' to the name part of the path.
-	 *
-	 * If the name is already 8+3 characters, then the name that appears inside the gmapsupp, will
-	 * not have the added character and so it is possible to have internal files with the same name.
-	 * I don't think this matters, since I don't think that the name is important, but I could be wrong.
-	 *
-	 * @param path The original name
-	 * @return The modified name.
-	 */
-	private static String makeOutName(String path) {
-		File f = new File(path);
-		File dir = f.getParentFile();
-
-		String name = f.getName();
-
-		File out = new File(dir, "x" + name);
-		return out.getPath();
-	}
 }
